## Copyright (C) 2002, 1000 ASA, http://www.1000asa.com
## Maintained by Giorgio Pieretti <giorgio@1000asa.com>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html

__version__ = "1.0 "
     

import os, urllib
from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFCore.WorkflowCore import WorkflowAction

# Import permission names
from Products.CMFCore import CMFCorePermissions
import CMFGenericProductPermissions
                           


factory_type_information = (
    {'id': 'CMFGenericProduct',
     'meta_type': 'CMFGenericProduct',
     'description': ('CMFGenericProduct give a set of 10 customizable fields.'),
     'product': 'CMFGenericProduct',
     'icon': 'generic_icon.gif',
     'factory': 'addCMFGenericProduct',
     'immediate_view': 'metadata_edit_form',
     'actions': ({'id': 'view',
                  'name': 'View',
                  'action': 'CMFGenericProduct_content_view',
                  'permissions': (CMFCorePermissions.View,)},
                 {'id': 'edit',
                  'name': 'Edit',
                  'action': 'CMFGenericProduct_content_edit_form',
                  'permissions': (CMFGenericProductPermissions.ChangeCMFGenericProduct,)},   
		{ 'id'		: 'metadata',
		  'name'	: 'Metadata',
		  'action'	: 'metadata_edit_form',
                  'permissions' : (CMFCorePermissions.ModifyPortalContent,)},                  
                 ),
     },
    )

def addCMFGenericProduct(self
				, id
				, field0=''
				, field1=''
                                , field2=''
                                , field3=''
                                , field4=''
                                , field5=''
                                , field6=''
                                , field7=''
                                , field8=''
                                , field9=''
				):
    """Create an CMFGenericProduct"""
    o=CMFGenericProduct( id=id
              , field0=field0
              , field1=field1
              , field2=field2
              , field3=field3
              , field4=field4
              , field5=field5
              , field6=field6
              , field7=field7
              , field8=field8
              , field9=field9
              )
    self._setObject(id, o)

class CMFGenericProduct(PortalContent, DefaultDublinCoreImpl):
 
    meta_type='CMFGenericProduct'
    
    ClassSecurityInfo().declareObjectPublic()
    
    def __init__(self, field0, field1, field2, field3, field4, field5, field6, field7, field8, field9, id):
        """Initialize an instance of the class"""
        DefaultDublinCoreImpl.__init__(self)
        
        self.id=id
        self.field0=field0
        self.field1=field1
        self.field2=field2
        self.field3=field3
        self.field4=field4
        self.field5=field5
        self.field6=field6
        self.field7=field7
        self.field8=field8
        self.field9=field9

        

    def edit(self, field0='', field1='', field2='', field3='', field4='', field5='', field6='', field7='', field8='', field9=''):

	## update infos
	self.field0 = field0
	self.field1 = field1
	self.field2 = field2
	self.field3 = field3
	self.field4 = field4
	self.field5 = field5
	self.field6 = field6
	self.field7 = field7
	self.field8 = field8
	self.field9 = field9


    edit = WorkflowAction(edit)

    def SearchableText(self):
    	""" Method used by search engine """
	return "%s %s %s %s %s %s %s %s %s %s" %(self.field0, self.field1, self.field2, self.field3, self.field4, self.field5, self.field6, self.field7, self.field8, self.field9)
    


InitializeClass(CMFGenericProduct)
    
