## Copyright (C) 2002, 1000 ASA, http://www.1000asa.com
## Maintained by Giorgio Pieretti <giorgio@1000asa.com>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html

__version__ = "1.0 "
from Products.CMFDefault import Portal
import CMFGenericProduct
import Products.CMFCore

from Products.CMFCore import utils, CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory
import CMFGenericProductPermissions

import sys
this_module = sys.modules[ __name__ ]

contentConstructors = (CMFGenericProduct.addCMFGenericProduct,)
contentClasses = (CMFGenericProduct.CMFGenericProduct,)

CMFGenericProduct_globals = globals()

z_bases = utils.initializeBasesPhase1(contentClasses, this_module)

# Make the skins available as DirectoryViews
registerDirectory('skins', globals())
registerDirectory('skins/CMFGenericProduct', globals())

def initialize(context):
    utils.initializeBasesPhase2( z_bases, context )
    utils.ContentInit('CMFGenericProduct',
                      content_types = contentClasses,
                      permission = CMFCorePermissions.AddPortalContent,
                      extra_constructors = contentConstructors,
                      fti = CMFGenericProduct.factory_type_information).initialize(context)
