## Copyright (C) 2002, 1000 ASA, http://www.1000asa.com
## Maintained by Giorgio Pieretti <giorgio@1000asa.com>
## Released under GPL version 2
## See LICENSE.txt or http://www.gnu.org/copyleft/gpl.html

__version__ = "1.0 "

from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFGenericProduct import CMFGenericProduct, CMFGenericProduct_globals
from cStringIO import StringIO
import string

def install(self):
    """Register CMFGenericProduct with the necessary tools"""
    out = StringIO()
    typestool = getToolByName(self, 'portal_types')
    skinstool = getToolByName(self, 'portal_skins')

    for t in CMFGenericProduct.factory_type_information:
        if t['id'] not in typestool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), t)
            typestool._setObject(t['id'], cfm)
            out.write('Registered with the types tool\n')
        else:
            out.write('Object "%s" already existed in the types tool\n' % (
                t['id']))

    # Setup the skins
    if 'CMFGenericProduct' not in skinstool.objectIds():
        addDirectoryViews(skinstool, 'skins', CMFGenericProduct_globals)
        out.write("Added 'CMFGenericProduct' directory view to portal_skins\n")

    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'CMFGenericProduct' not in path:
            try: path.insert(path.index('content'), 'CMFGenericProduct')
            except ValueError:
                path.append('CMFGenericProduct')
                
            path = string.join(path, ', ')
            skinstool.addSkinSelection(skin, path)
            out.write("Added 'CMFGenericProduct' to %s skin\n" % skin)
        else:
            out.write("Skipping %s skin, 'CMFGenericProduct' is already set up\n" % (
                skin))

    return out.getvalue()

